// x555 will be replaced soon
#define b555(c) ((c) & 31)
#define g555(c) (((c) >> 5) & 31)
#define r555(c) (((c) >> 10) & 31)
#define lum555(c) (b555(c) + g555(c) + r555(c))

// new macros for rgb = 565
#define b565(c) ((c) & 31)
#define g565(c) (((c) >> 5) & 63)
#define r565(c) (((c) >> 11) & 31)
#define lum565(c) (b565(c) + g565(c) + r565(c))

extern unsigned short *cap_buf;
extern XImage *ximage;
class mapped_image;
extern mapped_image *act_image;

extern int biWidth, biHeight;

extern int tcap;
void show_capt();
void map_and_redraw();
int comp_time();

// callback function to make a new mag_window and unmap it on second press
void toggle_magw();
void make_video_popup(); // button callback fn

// a class for drawing an infoline at the bottom of view_window
class info_window : public pixmap_window {
public:
  char info[200];
  info_window(window &parent,int w, int h, int x, int y) :
    pixmap_window(parent,w,h,x,y) { info[0] = 0; }
  virtual void draw_interior() { PlaceText(info); }
  char* infoend() { return (info + strlen(info)); } // for appending to end
};

class mag_window : public main_window {
  mapped_image *mag_im;
public:
  int fx, fy; // the magnification factors
  int sx, sy; // the src region size in view_window
  mag_window(char *name, int w, int h, int x = 400, int y = 25);
  void magnify(unsigned short *cap_buf, window *src_win, int x, int y);
};

class view_window : public window {
  info_window *infw;
public:
  int sx,sy; // the marked region size for magw
  XPoint mark; // origin of region
  mag_window *magw; // an optional magnifier window
  void (*redraw_chain)(); // to hook on functions to be called on redraw
  view_window(window &parent, int x, int y, info_window *infw);
  void Motion_CB(XMotionEvent ev);
  void BPress_CB(XButtonEvent ev);
  virtual void redraw();
  virtual void Expose_CB(XExposeEvent ev);
};

extern void (*BP_view_cb)(int, int); // possibly install a BPress callback here

extern view_window *grab_wi; // globally one !!

void create_buffers(int w, int h); // creates cap_buf && ximage

void adjust_size(int ww, int hh); // adjust size of main window

// specialized main_window creates menubar, view_window, info window
// handles resize events to set resolution (create buffers)
// and handle possibly actions from radio_menu
class display_main : public main_window {
public:
  menu_bar *menub;  
  info_window *infw;
  view_window *view;
  display_main(char *Name, int w, int h);
  // set resolution, resize grab_window & others
  virtual void resize(int w, int h);
  // from radio menu called :
  virtual void action(char* /* menu */, char* /* val */) { }
};
